use strict;
use Data::Dumper;

#my @months = get_months($ARGV[0]);
#print Dumper \@months;

unless (@ARGV) {
	print "Ԃw肵ĂiF2007-11~2008-8j";
	exit;
}

open my $out, ">", "history$ARGV[0].csv";

for(get_months($ARGV[0])) {
	my @files = <history/*history$_.cgi>;
	for (@files) {
		open my $in, "<", $_;
		my @history = <$in>;
		close $in;

		/(\d+)history.+\.cgi$/;
		open my $in, "<", "$1.cgi";
		my $info = <$in>;
		close $in;

		my ($name, $office) = split /,/, $info;

		for (@history) {
			my @item = split /,/, $_, -1;
			my ($date, $time) = split / |:/, $item[0];
			my @parts = split /<br>/, $item[8];
			for (@parts) {
				/^(.+)(\d+)$/;
				print $out "$name,$office,$date,$time";
				print $out ",$item[$_]" for 1..7;
				print $out ",$1,$2,$item[9]";
			}
		}
	}
}

close $out;

sub get_months {
	local $_ = shift;

	split /~/;
	unless ($_[1]) {
		$_[0] =~ s/-(\d)$/-0$1/;
		return $_[0];
	}

	my $from = new Date($_[0]);
	my $to = new Date($_[1]);
	my @months = ();
	my $period = $to - $from;

	if($period < 0) {
		print "Jnt͏ItߋɂĂ";
		exit;
	}

	for( 0..$period ) {
		push @months, "$from";
		$from++;
	}

	return @months;
}


package Date;

use overload (
		'++' => \&inc,
		'--' => \&dec,
		'-'  => \&minus,
		'""' => \&str,
);

sub new {
	my ($class, $date) = @_;

	my @date = split /\/|-/, $date;
	$date[1] = 12 if $date[1] > 12;
	$date[1] = 1  if $date[1] < 1;

	unless( $date[0] =~ /^\d+$/ and $date[1] =~ /^\d+$/ ) {
		require Carp;
		Carp::croak "t͐lŎw肵Ă";
	}

	return bless {year=>$date[0], month=>$date[1]}, $class;
}

sub inc {
	my $self = shift;

	if ($self->{month} == 12) {
		$self->{year}++;
		$self->{month} = 1;
	} else {
		$self->{month}++;
	}
}

sub dec {
	my $self = shift;

	if ($self->{month} == 1) {
		$self->{year}--;
		$self->{month} = 12;
	} else {
		$self->{month}--;
	}
}

sub str {
	my $self = shift;

	$self->{month} =~ s/^(\d)$/0$1/;
	return "$self->{year}-$self->{month}";
}

sub minus {
	my ($self, $other) = @_;

	my $dyear = $self->{year} - $other->{year};
	my $dmonth = $self->{month} - $other->{month};

	if ($dmonth < 0) {
		$dyear--;
		$dmonth += 12;
	}

	return $dyear*12 + $dmonth;
}
