package Date;
use strict;

use overload (
		'++' => \&inc,
		'--' => \&dec,
		'-'  => \&minus,
		'""' => \&str,
);

sub new {
	my ($class, $date) = @_;

	my @date = split /\/|-/, $date;
	$date[1] = 12 if $date[1] > 12;
	$date[1] = 1  if $date[1] < 1;

	unless( $date[0] =~ /^\d+$/ and $date[1] =~ /^\d+$/ ) {
		require Carp;
		Carp::croak "t͐lŎw肵Ă";
	}

	return bless {year=>$date[0], month=>$date[1]}, $class;
}

sub inc {
	my $self = shift;

	if ($self->{month} == 12) {
		$self->{year}++;
		$self->{month} = 1;
	} else {
		$self->{month}++;
	}
}

sub dec {
	my $self = shift;

	if ($self->{month} == 1) {
		$self->{year}--;
		$self->{month} = 12;
	} else {
		$self->{month}--;
	}
}

sub str {
	my $self = shift;

	$self->{month} =~ s/^(\d)$/0$1/;
	return "$self->{year}-$self->{month}";
}

sub minus {
	my ($self, $other) = @_;

	my $dyear = $self->{year} - $other->{year};
	my $dmonth = $self->{month} - $other->{month};

	if ($dmonth < 0) {
		$dyear--;
		$dmonth += 12;
	}

	return $dyear*12 + $dmonth;
}

1;