use strict;
use warnings;

use lib "./lib";
use CGI;
use YAML;
use Fcntl qw(:flock);
use Encode qw(from_to);
use Digest::MD5 qw(md5_hex);
use HTML::Template;
use HTML::FillInForm::Lite;

require "init.cgi";

our ($script, $top_page, $data_path, $session_path, $pc_path, $mobile_path,
     $history_path, $mpasswd_file, $setting_file, $salt, $lockdir, $lockfile,
     $sep, $sendmail, %data_pos);

#-----------------------------------------------------------
# f[^wt@Cɕۑ
# Ō̈$append^Ȃ΁Aǉ
#-----------------------------------------------------------
sub save_data {
	my ($file, $data, $append) = @_;
	my ($open_file, $open_method);

	if($append) {
		$open_file = $file;
		$open_method = ">>";
	} else {
		# ꎞt@CAɏ
		$open_file = $1.".tmp" if $file =~ /(.+)\..+$/;
		$open_method = ">";
	}

	open(my $out, $open_method, $open_file) or error("t@CG[", "$open_fileJ܂ in save_data");

	# bN(^CAEg)
	file_lock(file=>$open_file, filehandle=>$out) or error("t@CbNG[", "$open_filebNł܂ in save_data");

	print $out $data;
	close $out;

	rename($open_file, $file) unless($append);

	# AbN
	file_unlock($open_file);
}

#-----------------------------------------------------------
# wt@Cf[^ǂݍ
#-----------------------------------------------------------
sub read_data {
	my $file = shift;

	open(my $in, "<", $file) or return;
	my @data = <$in>;
	close $in;

	chomp @data;
	return wantarray ? @data : $data[0];
}

#-----------------------------------------------------------
# f[^t@Cw肳ꂽ擾
#-----------------------------------------------------------
sub get_data {
	my ($file, $data_name) = @_;
	my @data = get_info($file);

	return $data[$data_pos{$data_name}];
}

#-----------------------------------------------------------
# w肳ꂽf[^t@Cɕۑ
#-----------------------------------------------------------
sub set_data {
	my ($file, $data_name, $given_data) = @_;

	my @data = get_info($file);
	$data[$data_pos{$data_name}] = $given_data;

	save_data($file, join($sep, @data));
	return $given_data;
}

#-----------------------------------------------------------
# f[^t@CЏ擾
#-----------------------------------------------------------
sub get_info {
	my $file = shift;
	my $info;

	unless($info = read_data($file)) { error("t@CG[", "Џt@CJ܂", $top_page) }
	return split(/$sep/, $info);
}

#-----------------------------------------------------------
# Yf[^ƃt@CɕۑĂf[^Ƃ̐`FbN
#-----------------------------------------------------------
sub check_data {
	my ($file, $data_name, $data) = @_;

	if($data eq get_data($file, $data_name)) { return 1 }
	else { return }
}

#-----------------------------------------------------------
# GET/POSTp[^ZbVt@Cɕۑ
#-----------------------------------------------------------
sub set_params {
	my ($q, $replace) = @_;
	my $session_id = $q->param("session_id");
	my $session_file = "$session_path/$session_id.cgi";

	my $new_q = new CGI($q);

	# [h͕ۑȂ
	$new_q->delete("passwd2", "mode", "session_id", "submit");

	open my $in, "<", $session_file or error("ZbVIDG[", "ZbVIDt@CJ܂", $top_page);
	my $saved_q = new CGI($in);
	close $in;

	if($replace) { # SẴp[^uꍇ
		$new_q->param("tel", $saved_q->param("tel")); # dbԍ͒uĂ
		$new_q->param("mobile", $saved_q->param("mobile")); # gя͒uĂ
		$new_q->param("passwd", $saved_q->param("passwd")); # pX[h͒uĂ
		$new_q->param("Ǘ", $saved_q->param("Ǘ")); # Ǘ͒uĂ
		$saved_q = $new_q;
	} else {
		$saved_q->param($_, $new_q->param($_)) for $new_q->param;
	}

	open my $out, ">", $session_file or error("ZbVIDG[", "ZbVIDt@CJ܂", $top_page);
	$saved_q->save($out);
	close $out;
}

#-----------------------------------------------------------
# ZbVt@CɕۑĂGET/POSTp[^̕A
#-----------------------------------------------------------
sub get_params {
	my $new_q = shift;
	my $session_id = $new_q->param("session_id");

	# ZbVIDp[^ȂΈ̂܂ܕԂ
	return $new_q unless $session_id;

	open my $in, "<", "$session_path/$session_id.cgi" or error("ZbVIDG[", "ZbVIDt@CJ܂", $top_page);
	my $saved_q = new CGI($in);
	close $in;

	$saved_q->param($_, $new_q->param($_)) for $new_q->param;

	if( $new_q->param("mode") eq "preview" and !$new_q->param("i") ) {
		$saved_q->delete("i");
	}

	return $saved_q;
}

#-----------------------------------------------------------
# pX[h̐`FbN
#-----------------------------------------------------------
sub check_passwd {
	my $q = shift;
	my $tel = $q->param("tel");
	my $file = "$data_path/$tel.cgi";
	my $passwd = $q->param("passwd").$salt;
	my $passwd2 = $q->param("passwd2").$salt; # mFpɍē͂pX[h

	if( $q->param("Ǘ") ) {
		check_master_passwd($mpasswd_file, $passwd) or error("pX[hG[", "pX[hv܂");
	} else {
		check_user_passwd($file, $passwd, $passwd2) or error("pX[hG[", "pX[hv܂");
	}
}

#-----------------------------------------------------------
# [U[̃pX[h̐`FbN
# t@CɈÍꂽpX[hۑĂȂ΍쐬
#-----------------------------------------------------------
sub check_user_passwd {
	my ($file, $passwd, $passwd2) = @_;
	my $crypt_passwd = get_data($file, "pX[h");

	if($crypt_passwd eq "") {
		if($passwd ne $passwd2) { error("pX[hG[", "ē͂pX[hǈv܂") }
		set_data($file, "pX[h", cipher($passwd)); # Íĕۑ
		return 1;
	}

	return check_data($file, "pX[h", cipher($passwd));
}

#-----------------------------------------------------------
# }X^[pX[h̐`FbN
# t@CɈÍꂽ}X^[pX[hۑĂȂ΍쐬
#-----------------------------------------------------------
sub check_master_passwd {
	my ($file, $passwd) = @_;
	my $crypt_passwd = "";

	if(open(my $in, "<", $file)) {
		$crypt_passwd = <$in>;
		close $in;
	}

	if($crypt_passwd eq "") {
		$crypt_passwd = cipher($passwd);
		save_data($file, $crypt_passwd);
	}

	if(cipher($passwd) eq $crypt_passwd) {
		return 1;
	} else {
		return;
	}
}

#-----------------------------------------------------------
# tH[̓͒l`FbN
#-----------------------------------------------------------
sub check_input {
	my $q = shift;
	my @error;

	if( $q->param("[J[") !~ /\Qg^\E|\QY\E|\Qz_\E|\Q}c_\E|\QOH\E|\Q_Cnc\E|\QXYL\E|\QY̑\E|\QO\E/ ) { push @error, ["ԑ̃[J[", ""] } 
	if( $q->param("") !~ /|a/ ) { push @error, ["Ň", ""] }
	if( $q->param("N") !~ /^\d{1,2}$/ ) { push @error, ["N̔N", "i1`2̐lłȂj"] }
	if( $q->param("") !~ /^([1-9]?|1[012])$/ ) { push @error, ["Ň", "i1`12̐lłȂj"] }
	if( $q->param("^") !~ /^.{1,30}$/ ) { push @error, ["^", "i͕͂I[o[j"] }
	if( $q->param("ԑ̔ԍ") !~ /^.{1,30}$/ ) { push @error, ["ԑ̔ԍ", "i͕͂I[o[j"] } 
	if( $q->param("^w") !~ /^\d{0,6}$/ ) { push @error, ["^w", "i6ȓ̐lłȂj"] }
	if( $q->param("ޕʔԍ") !~ /^\d{0,4}$/ ) { push @error, ["ޕʔԍ", "i4ȓ̐lłȂj"] }
	if( $q->param("̑") !~ /^.{0,400}$/m ) { push @error, ["̑", "i܂j"] }
	if( $q->param("S") !~ /^.{0,20}$/ ) { push @error, ["Sҗl", "i܂j"] }

	# ZbeBOt@C畔i[h
	open my $in, $setting_file or error("ZbeBOt@CG[", "ZbeBOt@CJ܂");
	my ($parts_names) = Load do { local $/; <$in> };
	close $in;

	my $regexp = "";
	for my $category (@$parts_names) {
		$regexp .= "\Q$_\E|" for @{$category->[1]};
	}
	chop $regexp;

	my @parts = $q->param("i");
	unless ( @parts or $q->param("̑") ) { push @error, ["i", "iȋI͂̑ւ̋L܂j"] }

	for (@parts) {
		if($_ !~ /$regexp/) { push @error, ["i", "iÎȂiłj"] }
		if( $q->param("$_") !~ /^\d{1,2}$/ ) { push @error, ["$_̌", "i1`2̐lłȂj"] }
	}

	if (@error) {
		my %var;
		$var{"G[e"} .= qq(<p><font size="-1">E$$_[0]̓͒lsł<br> $$_[1]<font></p>\n) for @error;
		display($q, "input-error.html", \%var);
		exit;
	}
}

#-----------------------------------------------------------
# t@CbNifBNg쐬Ŏj
#-----------------------------------------------------------
sub file_lock {
	my %args = @_;

	# flock֐gp\`FbN
	eval {flock LOCKCHK, LOCK_UN};
	unless ( $@ ) {
		flock $args{filehandle}, LOCK_EX or return;
		return 1;
	}

	$args{file} =~ m{([^/]+)\..+$};
	my $lockdir = $1."dir";

	# bNfBNg쐬A1b5gC
	for(1..5){
		return 1 if( mkdir($lockdir, 0755) );
		sleep(1);
	}

	# bNfBNg10ȏuĂꍇ́AbN\Ƃ݂
	my $is_locked;
	if( my $lfh = my_flock() ) {         # bNfBNgXV̂߂̔r
		if ( (-M $lockdir) * 24 * 60 > 10 ) { # 쐬Ԃ10ȏOȂ
			rmdir $lockdir and mkdir $lockdir and $is_locked = 1;
		}
		my_funlock($lfh); # AbN
	}

	return $is_locked;
}

#-----------------------------------------------------------
# t@CbNibNfBNg̍폜j
#-----------------------------------------------------------
sub file_unlock {
	my $file = shift;

	$file =~ m{([^/]+)\..+$};
	my $lockdir = $1."dir";

	rmdir($lockdir);
}

#-----------------------------------------------------------
# t@CbNiPerlj
#-----------------------------------------------------------
sub my_flock {
	my %lfh = (dir => $lockdir, basename => $lockfile, timeout => 60, trytime => 2, @_);
	$lfh{path} = $lfh{dir} . $lfh{basename};

	for (0..$lfh{trytime}) {
		return \%lfh if (rename($lfh{path}, $lfh{current} = $lfh{path} . time));
		sleep 1;
	}

	opendir my $lockdir, $lfh{dir};
	my @filelist = readdir $lockdir;
	closedir $lockdir;

	foreach (@filelist) {
		if (/^$lfh{basename}(\d+)/) {
			if (time - $1 > $lfh{timeout} and rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time)) {
				return \%lfh;
			}
			last;
		}
	}
	return;
}

#-----------------------------------------------------------
# t@CbNiPerlj
#-----------------------------------------------------------
sub my_funlock {
	rename($_[0]->{current}, $_[0]->{path});
}

#-----------------------------------------------------------
# NXTCgXNveBOȂ悤HTML^OGXP[v
#-----------------------------------------------------------
sub html_escape {
	my $data = shift;

	$data =~ s/&/&amp;/g;   #ApThr
	$data =~ s/</&lt;/g;    #^Or
	$data =~ s/>/&gt;/g;    #^Or
	$data =~ s/"/&quot;/g;  #_uNH[gr
	$data =~ s/'/&#39;/g;   #VONH[gr
	$data =~ s/\x0D\x0A|\x0D|\x0A/<br>/g; #sR[h<br>^O

	return $data;
}

#-----------------------------------------------------------
# t@CɏނƂQo镶GXP[v
#-----------------------------------------------------------
sub file_escape {
	my $data = shift;

	$data =~ s/$sep/C/g; #Zp[gSpJ}
	$data =~ s/\x0D\x0A|\x0D|\x0A/<br>/g; #sR[h<br>^O

	return $data;
}

#-----------------------------------------------------------
# t@CݎɃGXP[vɖ߂
#-----------------------------------------------------------
sub file_unescape {
	my $data = shift;

	$data =~ s/C/$sep/g; # SpJ}Zp[g
	$data =~ s/<br>/\n/g; # <br>^Osނ

	return $data;
}

#-----------------------------------------------------------
# iƂ̌ABeX悤ɐ`B
#-----------------------------------------------------------
sub make_parts_string {
	my $q = shift;
	my (@quantities, $parts_string);

	my @parts = $q->param("i");
	push @quantities, $q->param("$_") for @parts;

	my @sorted_parts = sort { length $b <=> length $a } @parts;
	my @sorted_quantities = sort { length $b <=> length $a } @quantities;
	my $max_part = length $sorted_parts[0]; # i̍ő咷
	my $max_quantity = length $sorted_quantities[0]; # i̍ő咷

	$parts_string .= sprintf("%-${max_part}s   %${max_quantity}d\n", $parts[$_], $quantities[$_]) for 0..$#parts;
	chomp $parts_string;

	return $parts_string;
}

#-----------------------------------------------------------
# Í
#-----------------------------------------------------------
sub cipher {
	return md5_hex($_[0]);
}

#-----------------------------------------------------------
# _ID𔭍s
#-----------------------------------------------------------
sub generate_id {
	return cipher($$.time.rand(time));
}

#-----------------------------------------------------------
# HTMLev[gt@CgāAʂo
# FillInFormW[gāAtH[̒l𕜌
#-----------------------------------------------------------
sub display {
	my ($q, $file, $var, @form) = @_;
	my ($tmpl, $form, $html);

	if( $q->param("mobile") ) {
		$file = "$mobile_path/$file";
	} else {
		$file = "$pc_path/$file";
	}

	$tmpl = HTML::Template->new(
			filename => $file,
			associate => $q,
	);

	$tmpl->param(%{$var});
	$html = $tmpl->output;

	$form = HTML::FillInForm::Lite->new;
	for (@form) {
		$html = $form->fill( \$html, $q,
#				target => $_,
				ignore_fields => ["mode", "gUNVID"],
		);
	}

	print "Content-Type: text/html\n\n";
	print $html;
}

#-----------------------------------------------------------
# G[o
#-----------------------------------------------------------
sub error {
	my %var;

	$var{"G["} = $_[0];
	$var{"G[e"} = $_[1];
	$var{"߂郊N"} = $_[2];

	display( new CGI, "error.html", \%var );
	exit;
}

#-----------------------------------------------------------
# [MB ̓nbVœn
# to=> cc=> bcc=> from=> sub=> body=> name=>
#-----------------------------------------------------------
sub send_mail {
	my %m = @_;

	$m{sub} = base64($m{sub});
	$m{name} = base64($m{name});

	# sendmailM
	open(MAIL,"| $sendmail -t") or error("[MG[", "sendmailJ܂");;
	print MAIL "To: $m{to}\n"       if ( exists( $m{to} )   and  $m{to} ne '');
	print MAIL "Cc: $m{cc}\n"       if ( exists( $m{cc} )   and  $m{cc} ne '' );
	print MAIL "Bcc: $m{bcc}\n"     if ( exists( $m{bcc} )  and  $m{bcc} ne '' );
	print MAIL "From: $m{name} <$m{from}>\n" if ( exists( $m{from} ) and  $m{from} ne '' );
	print MAIL "Subject: $m{sub}\n" if ( exists( $m{sub} )  and  $m{sub} ne '' );
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: \n\n";
	for ( split(/\n/, $m{body}) ) {
		from_to($_, "cp932", "jis");
		print MAIL $_, "\n";
	}
	close(MAIL);
	return 1;
}

#-----------------------------------------------------------
# BASE64ϊ
#-----------------------------------------------------------
#	ƂققWWWŌJĂ郋[`
#	Qlɂ܂B( http://tohoho.wakusei.ne.jp/ )
sub base64 {
	my $sub = shift;
	from_to($sub, "cp932", "jis");

	$sub =~ s/\x1b\x28\x42/\x1b\x28\x4a/g;
	$sub = "=?iso-2022-jp?B?" . b64enc($sub) . "?=";
	$sub;
}
sub b64enc {
	my $ch = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	my ($x, $y, $z, $i);
	$x = unpack("B*", $_[0]);
	for ($i=0; $y=substr($x,$i,6); $i+=6) {
		$z .= substr($ch, ord(pack("B*", "00" . $y)), 1);
		if (length($y) == 2) {
			$z .= "==";
		} elsif (length($y) == 4) {
			$z .= "=";
		}
	}
	$z;
}

1;